multiplex.sh revision 137015
1#	$OpenBSD: multiplex.sh,v 1.8 2004/06/22 03:12:13 markus Exp $
2#	Placed in the Public Domain.
3
4CTL=$OBJ/ctl-sock
5
6tid="connection multiplexing"
7
8DATA=/bin/ls${EXEEXT}
9COPY=$OBJ/ls.copy
10
11start_sshd
12
13trace "start master, fork to background"
14${SSH} -2 -MS$CTL -F $OBJ/ssh_config -oSendEnv="_XXX_TEST" -f somehost sleep 120
15
16verbose "test $tid: envpass"
17trace "env passing over multiplexed connection"
18_XXX_TEST=blah ${SSH} -oSendEnv="_XXX_TEST" -S$CTL otherhost sh << 'EOF'
19	test X"$_XXX_TEST" = X"blah"
20EOF
21if [ $? -ne 0 ]; then
22	fail "environment not found"
23fi
24
25verbose "test $tid: transfer"
26rm -f ${COPY}
27trace "ssh transfer over multiplexed connection and check result"
28${SSH} -S$CTL otherhost cat ${DATA} > ${COPY}
29test -f ${COPY}			|| fail "ssh -Sctl: failed copy ${DATA}" 
30cmp ${DATA} ${COPY}		|| fail "ssh -Sctl: corrupted copy of ${DATA}"
31
32rm -f ${COPY}
33trace "ssh transfer over multiplexed connection and check result"
34${SSH} -S $CTL otherhost cat ${DATA} > ${COPY}
35test -f ${COPY}			|| fail "ssh -S ctl: failed copy ${DATA}" 
36cmp ${DATA} ${COPY}		|| fail "ssh -S ctl: corrupted copy of ${DATA}"
37
38rm -f ${COPY}
39trace "sftp transfer over multiplexed connection and check result"
40echo "get ${DATA} ${COPY}" | \
41	${SFTP} -S ${SSH} -oControlPath=$CTL otherhost >/dev/null 2>&1
42test -f ${COPY}			|| fail "sftp: failed copy ${DATA}" 
43cmp ${DATA} ${COPY}		|| fail "sftp: corrupted copy of ${DATA}"
44
45rm -f ${COPY}
46trace "scp transfer over multiplexed connection and check result"
47${SCP} -S ${SSH} -oControlPath=$CTL otherhost:${DATA} ${COPY} >/dev/null 2>&1
48test -f ${COPY}			|| fail "scp: failed copy ${DATA}" 
49cmp ${DATA} ${COPY}		|| fail "scp: corrupted copy of ${DATA}"
50
51rm -f ${COPY}
52
53for s in 0 1 4 5 44; do
54	trace "exit status $s over multiplexed connection"
55	verbose "test $tid: status $s"
56	${SSH} -S $CTL otherhost exit $s
57	r=$?
58	if [ $r -ne $s ]; then
59		fail "exit code mismatch for protocol $p: $r != $s"
60	fi
61
62	# same with early close of stdout/err
63	trace "exit status $s with early close over multiplexed connection"
64	${SSH} -S $CTL -n otherhost \
65                exec sh -c \'"sleep 2; exec > /dev/null 2>&1; sleep 3; exit $s"\'
66	r=$?
67	if [ $r -ne $s ]; then
68		fail "exit code (with sleep) mismatch for protocol $p: $r != $s"
69	fi
70done
71
72# kill master, remove control socket.  ssh -MS will exit when sleep exits
73$SUDO kill `cat $PIDFILE`
74rm -f $CTL
75